package agent.agentgui;

import com.borland.jbcl.layout.*;
import java.awt.*;
import java.awt.event.*;

import agent.Agent;
import mailbox.Message;


/**
 * Diese Klasse stellt eine einfache Fernsteuerung fr einen Agenten zur
 * Verfgung, mit der Mglichkeit zu drehen, sich zu bewegen oder zu scannen.
 * @author unbekannt
 * @version 1.0
 */

public class SimpleAgentRemoteControl extends Frame {

  XYLayout xYLayout1 = new XYLayout();
  Panel panel1 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Button button1 = new Button();
  Button button3 = new Button();
  Button button4 = new Button();
  Button button5 = new Button();
  Button button6 = new Button();
  Button button7 = new Button();
  Button button8 = new Button();
  Button button9 = new Button();
  Button button2 = new Button();
  Panel panel2 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Button button10 = new Button();
  Button button11 = new Button();
  private  VisualScanResult ivVisualScanResult = new VisualScanResult();
  private Agent ivAgent;
    private String ivEnergy = "";
  Button button12scan = new Button();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  ScrollPane scrollPane1 = new ScrollPane();
  Choice choicezoom = new Choice();
  Button button13remove = new Button();
  Button button14engergie = new Button();
  TextField engeryDisplay = new TextField();



  public SimpleAgentRemoteControl() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(xYLayout1);
    panel1.setLayout(gridLayout1);
    gridLayout1.setColumns(3);
    gridLayout1.setRows(3);
    button1.setFont(new java.awt.Font("Dialog", 0, 10));
    button1.setLabel("NW");
    button1.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button3.setLabel("dummy");
    button3.setVisible(false);
    button4.setFont(new java.awt.Font("Dialog", 0, 10));
    button4.setLabel("N");
    button4.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button5.setFont(new java.awt.Font("Dialog", 0, 10));
    button5.setLabel("W");
    button5.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button6.setFont(new java.awt.Font("Dialog", 0, 10));
    button6.setLabel("S");
    button6.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button7.setFont(new java.awt.Font("Dialog", 0, 10));
    button7.setLabel("NO");
    button7.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button8.setFont(new java.awt.Font("Dialog", 0, 10));
    button8.setLabel("SW");
    button8.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button9.setFont(new java.awt.Font("Dialog", 0, 10));
    button9.setLabel("O");
    button9.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    button2.setFont(new java.awt.Font("Dialog", 0, 10));
    button2.setLabel("SO");
    button2.addActionListener(new SimpleAgentRemoteControl_button1_actionAdapter(this));
    panel2.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(2);
    button10.setLabel("V");
    button10.addActionListener(new SimpleAgentRemoteControl_button10_actionAdapter(this));
    button11.setLabel("R");
    button11.addActionListener(new SimpleAgentRemoteControl_button10_actionAdapter(this));
    button12scan.setLabel("Scan");
    button12scan.addActionListener(new SimpleAgentRemoteControl_button12scan_actionAdapter(this));
    xYLayout1.setWidth(276);
    xYLayout1.setHeight(475);
    button13remove.addActionListener(new SimpleAgentRemoteControl_button13remove_actionAdapter(this));
    button13remove.setFont(new java.awt.Font("SansSerif", 0, 11));
    button13remove.setLabel("Rumen");
    button14engergie.addActionListener(new SimpleAgentRemoteControl_button14engergie_actionAdapter(this));
    button14engergie.setLabel("Energie");
    engeryDisplay.setEditable(false);
    engeryDisplay.setText("");
    choicezoom.add("25");
    choicezoom.add("50");
    choicezoom.add("75");
    choicezoom.add("100");
    choicezoom.add("125");
    choicezoom.add("150");
    choicezoom.select("100");

    choicezoom.addItemListener(new SimpleAgentRemoteControl_choicezoom_itemAdapter(this));
    panel1.add(button1, null);
    panel1.add(button4, null);
    panel1.add(button7, null);
    panel1.add(button5, null);
    panel1.add(button3, null);
    panel1.add(button9, null);
    panel1.add(button8, null);
    panel1.add(button6, null);
    panel1.add(button2, null);
    this.add(button14engergie,  new XYConstraints(18, 112, 71, 24));
    this.add(button13remove,    new XYConstraints(17, 173, 71, 24));
    this.add(scrollPane1, new XYConstraints(20, 241, 220, 220));
    this.add(choicezoom,  new XYConstraints(18, 207, 60, 23));
    scrollPane1.add(ivVisualScanResult);
    ivVisualScanResult.setSize(420, 420);
    this.setSize(300, 500);



    this.add(button12scan,    new XYConstraints(18, 143, 71, 24));
    this.add(panel2,  new XYConstraints(190, 28, 43, 74));
    panel2.add(button10, null);
    panel2.add(button11, null);
    this.add(panel1,               new XYConstraints(19, 28, 151, 77));
    this.add(engeryDisplay,  new XYConstraints(100, 113, 121, 24));
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        setVisible(false);
      }
    });
  }

   // Setzt die Buttonkommandos in Drehungen um
  void buttondir_actionPerformed(ActionEvent e) {
        String lvDirection = e.getActionCommand();
      if (lvDirection.equals(button1.getLabel())){ // NW
          ivAgent.sendMessageToServer(new Message(Message.TURNNORTHWEST));
      } else if (lvDirection.equals(button2.getLabel())){ // SO
          ivAgent.sendMessageToServer(new Message(Message.TURNSOUTHEAST));
      } else if (lvDirection.equals(button4.getLabel())){ //  N
           ivAgent.sendMessageToServer(new Message(Message.TURNNORTH));
      } else if (lvDirection.equals(button5.getLabel())){  // W
           ivAgent.sendMessageToServer(new Message(Message.TURNWEST));
      } else if (lvDirection.equals(button6.getLabel())){  //  S
           ivAgent.sendMessageToServer(new Message(Message.TURNSOUTH));
      } else if (lvDirection.equals(button7.getLabel())){  // NO
           ivAgent.sendMessageToServer(new Message(Message.TURNNORTHEAST));
      } else if (lvDirection.equals(button8.getLabel())){  // SW
           ivAgent.sendMessageToServer(new Message(Message.TURNSOUTHWEST));
      } else if (lvDirection.equals(button9.getLabel())){  // O
           ivAgent.sendMessageToServer(new Message(Message.TURNEAST));
      } else {
         // do nothing
      }

  }

    // Setzt die Buttonkommandos in Bewegungen um
  void buttonmove_actionPerformed(ActionEvent e) {
      String lvMove = e.getActionCommand();

      if (lvMove.equals(button10.getLabel())){
          ivAgent.sendMessageToServer(new Message(Message.MOVEFORWARD));
      } else if (lvMove.equals(button11.getLabel())){
          ivAgent.sendMessageToServer(new Message(Message.MOVEBACKWARD));
      }

  }

    public void setZoomfactor(int zoomfactor) {
        ivVisualScanResult.setZoomfactor(zoomfactor);
    }


  public Agent getAgent() {
        return ivAgent;
  }

    public void setAgent(Agent ivAgent) {
        this.ivAgent = ivAgent;
        this.setTitle("Control fr " + ivAgent.getName());
        String [] lvSensoren = this.ivAgent.getRoboterInfo().getSensoren();
        this.checkboxGroup1 = new CheckboxGroup();
        if (lvSensoren.length > 0 ){

          for (int i = 0; i < lvSensoren.length; i++) {
              boolean lvSelected = false;
              if (i == 0){lvSelected = true;}
             System.out.println("Remotecontrol sensor setting" + lvSensoren[i]);
             Checkbox c = new Checkbox(lvSensoren[i], checkboxGroup1, lvSelected);
             this.add(c,  new XYConstraints( 100 ,(140 + (i * 20)), 163, 20));
          }

        }
    }

    public String getEnergy() {
        return ivEnergy;
    }

    public void setEnergy(String ivEnergy) {
        this.ivEnergy = ivEnergy;
        this.engeryDisplay.setText(ivEnergy);
        this.engeryDisplay.repaint();
    }

  // Setzt die Buttonkommandos in einen Scan mit dem ausgewhlten Sensor um
  void button12scan_actionPerformed(ActionEvent e) {
       String selectedSensor = checkboxGroup1.getSelectedCheckbox().getLabel();
       ivAgent.sendMessageToServer(new Message(Message.SCAN, selectedSensor));
  }

    public synchronized void setScanResult(Image[][] receivedImages){
        this.ivVisualScanResult.setIvResolvedImages(receivedImages);
        this.ivVisualScanResult.repaint();
        this.scrollPane1.doLayout();


    }

  void choicezoom_itemStateChanged(ItemEvent e) {
      setZoomfactor(Integer.parseInt(choicezoom.getSelectedItem()));
      choicezoom.doLayout();


  }

  void button13remove_actionPerformed(ActionEvent e) {
    ivAgent.sendMessageToServer(new Message(Message.REMOVEMINE));
  }

  void button14engergie_actionPerformed(ActionEvent e) {
    ivAgent.sendMessageToServer(new Message(Message.GETENERGY));
  }



}

class SimpleAgentRemoteControl_button1_actionAdapter implements java.awt.event.ActionListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_button1_actionAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttondir_actionPerformed(e);
  }
}

class SimpleAgentRemoteControl_button10_actionAdapter implements java.awt.event.ActionListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_button10_actionAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonmove_actionPerformed(e);
  }
}

class SimpleAgentRemoteControl_button12scan_actionAdapter implements java.awt.event.ActionListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_button12scan_actionAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button12scan_actionPerformed(e);
  }
}

class SimpleAgentRemoteControl_choicezoom_itemAdapter implements java.awt.event.ItemListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_choicezoom_itemAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.choicezoom_itemStateChanged(e);
  }
}

class SimpleAgentRemoteControl_button13remove_actionAdapter implements java.awt.event.ActionListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_button13remove_actionAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button13remove_actionPerformed(e);
  }
}

class SimpleAgentRemoteControl_button14engergie_actionAdapter implements java.awt.event.ActionListener {
  SimpleAgentRemoteControl adaptee;

  SimpleAgentRemoteControl_button14engergie_actionAdapter(SimpleAgentRemoteControl adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button14engergie_actionPerformed(e);
  }
}