package agent.agentgui;

import com.borland.jbcl.layout.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import agent.Agent;

    /**
     * Diese Klasse stellt eine einfache GUI zur Verfgung, die nur die
     * Scan-Ergebnisse des Agenten anzeigen kann. Interaktion ist nicht
     * mglich.
     * @author unbekannt
     * @version 1.0
     */

public class SimpleAgentVisualization extends Frame {
      XYLayout xYLayout1 = new XYLayout();
      ScrollPane scrollPane1 = new ScrollPane();
      private VisualScanResult ivVisualScanResult = new VisualScanResult();
      private Agent ivAgent;


      public SimpleAgentVisualization() throws HeadlessException {
        try {
          jbInit();
        }
        catch(Exception e) {
          e.printStackTrace();
        }
      }


     private void jbInit() throws Exception {
        this.setLayout(xYLayout1);
        xYLayout1.setWidth(462);
        xYLayout1.setHeight(455);
        scrollPane1.add(ivVisualScanResult);
        this.add(scrollPane1,   new XYConstraints(20, 20, 420, 420));
        this.setSize(460, 460);
         addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        setVisible(false);
      }
    });
     }


     public void setAgent(Agent ivAgent) {
        this.ivAgent = ivAgent;
        this.setTitle("Visualisierung fr " + ivAgent.getName());
     }


        public synchronized void setScanResult(Image[][] receivedImages){
        this.ivVisualScanResult.setIvResolvedImages(receivedImages);
        this.ivVisualScanResult.repaint();
        this.scrollPane1.doLayout();


    }

}