package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.*;
import java.util.Vector;
import java.util.Enumeration;

/**
 * Maske zum anlegen und ndern von Robotern
 */

public class Robotergui
    extends Frame {
  // Herstellen der bentigten Datenbankverbindungen
  Sql db = new Sql();
  Sql db2 = new Sql();

  int andernid = 0; //id des zu ndernden Datensatzen, bei neu anlegen 0
  String altername;
  Vector vsensoren = new Vector(10);
  XYLayout xYLayout1 = new XYLayout();
  Choice antriebe = new Choice();
  Choice csensoren = new Choice();
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label9 = new Label();
  TextField tname = new TextField();
  TextField tleistung = new TextField();
  TextField tenergie = new TextField();
  Button bbild = new Button();
  Label label8 = new Label();
  TextField tbild = new TextField();
  Button babbrechen = new Button();
  Button beintragen = new Button();
  Label label10 = new Label();
  Button bsensor = new Button();
  TextField tgewicht = new TextField();
  List lsensoren = new List();
  Button bsensordel = new Button();

    /**
     * Konstruktor fr das Erstellen eines neuen Roboters
     */
  public Robotergui() {
    super("Roboter anlegen");
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  /**
   * Konstruktor fr das ndern eines vorhandenen Roboters
   * @param zuandern Name des betreffenden Roboters
   */
  public Robotergui(String zuandern) {
    super("Roboter anlegen");
    try {
      jbInit();
      // Auslesen der vorhandenen Daten aus der Datenbank
      ResultSet altedaten;
      altedaten = db.select("select rid, roboter.name, sendereichweite, energievorrat, bild, roboter.gewicht,antrieb.name as antrieb from roboter,antrieb where roboter.name='" +
                            zuandern + "' and roboter.aid=antrieb.aid");
      label1.setText("Roboter ndern");
      beintragen.setLabel("ndern");
      altedaten.next();
      andernid = altedaten.getInt("rid");
      tname.setText(altedaten.getString("name"));
      tleistung.setText(altedaten.getString("sendereichweite"));
      tenergie.setText(altedaten.getString("energievorrat"));
      tbild.setText(altedaten.getString("bild"));
      tgewicht.setText(altedaten.getString("gewicht"));
      antriebe.select(altedaten.getString("antrieb"));
      altedaten = db.select(
          "select sensor.name from rszuordnung, sensor,umgsensorz where rid='" + andernid +
          "'and sensor.sid=rszuordnung.sid and sensor.sid=umgsensorz.sid and umgsensorz.uid='"+Editor.getumgebung()+"'");
      altername = new String(tname.getText());
      while (altedaten.next()) {
        lsensoren.add(altedaten.getString("name"));
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
 //Mainmethode zu Testzwecken
  public static void main(String[] args) {
    Robotergui robotergui1 = new Robotergui("Superman");
  }

  private void jbInit() throws Exception { //Aufbauen der Eingabemaske
    ResultSet result;
    result = db.select("select name from antrieb,umgantriebz where antrieb.aid=umgantriebz.aid and umgantriebz.uid='"+Editor.getumgebung()+"'");
    try {
      while (result.next()) {
        antriebe.add(result.getString("name"));
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Antriebspulldown " + ex);
    }
    ResultSet sensorenres;
    sensorenres = db.select("select name from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='"+Editor.getumgebung()+"'");
    try {
      while (sensorenres.next()) {
        csensoren.add(sensorenres.getString("name"));
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Antriebspulldown " + ex);
    }

    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Neuen Roboter anlegen");
    this.setBackground(SystemColor.control);
    this.setLayout(xYLayout1);
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Name:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setText("Sendeleistung:");
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    label4.setText("Energievorrat:");
    label5.setFont(new java.awt.Font("Dialog", 0, 13));
    label5.setText("Gewicht:");
    label9.setFont(new java.awt.Font("Dialog", 0, 13));
    label9.setText("Antrieb:");
    xYLayout1.setWidth(476);
    xYLayout1.setHeight(295);
    tname.setText("");
    tleistung.setColumns(0);
    tleistung.setText("");
    tenergie.setText("");
    tgewicht.setText("");
    bbild.setLabel("Suchen...");
    bbild.addMouseListener(new robotergui_bbild_mouseAdapter(this));
    label8.setFont(new java.awt.Font("Dialog", 0, 13));
    label8.setText("Bild:");
    tbild.setText("");
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new robotergui_babbrechen_actionAdapter(this));
    beintragen.setLabel("Eintragen");
    beintragen.addActionListener(new robotergui_beintragen_actionAdapter(this));
    label10.setText("Sensoren:");
    label10.setFont(new java.awt.Font("Dialog", 0, 13));
    bsensor.setLabel("Hinzufgen");
    bsensor.addActionListener(new robotergui_bsensor_actionAdapter(this));
    tgewicht.setText("");
    bsensordel.addActionListener(new robotergui_bsensordel_actionAdapter(this));
    bsensordel.setLabel("Entfernen");
    bsensordel.addActionListener(new robotergui_bsensordel_actionAdapter(this));
    this.add(label2, new XYConstraints(18, 45, 79, 22));
    this.add(label3, new XYConstraints(18, 70, 94, 22));
    this.add(label4, new XYConstraints(18, 95, -1, 22));
    this.add(label5, new XYConstraints(268, 44, 55, 22));
    this.add(tname, new XYConstraints(112, 45, 128, 21));
    this.add(tleistung, new XYConstraints(112, 70, 128, 21));
    this.add(tenergie, new XYConstraints(112, 95, 128, 21));
    this.add(tgewicht, new XYConstraints(332, 46, 128, 21));
    this.add(label1, new XYConstraints(160, 7, 179, 21));
    this.add(tgewicht, new XYConstraints(332, 44, 128, 21));
    this.add(antriebe, new XYConstraints(333, 70, 128, 21));
    this.add(label9, new XYConstraints(268, 70, 54, 22));
    this.add(label8, new XYConstraints(18, 120, 79, 22));
    this.add(tbild, new XYConstraints(112, 120, 128, 21));
    this.add(label10, new XYConstraints(18, 156, 65, 22));
    this.add(babbrechen, new XYConstraints(361, 220, 100, 23));
    this.add(beintragen, new XYConstraints(361, 250, 100, 23));
    this.add(lsensoren, new XYConstraints(33, 181, 134, 93));
    this.add(csensoren, new XYConstraints(174, 181, 113, 21));
    this.add(bsensor, new XYConstraints(174, 207, 100, 23));
    this.add(bsensordel, new XYConstraints(174, 250, 100, 23));
    this.add(bbild, new XYConstraints(251, 120, 100, 23));
    pack();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });

  }

  void babbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    //berprfen der eingetragenen Werte
    if (tname.getText().equals("") || tleistung.getText().equals("") ||
        tenergie.getText().equals("") || tbild.getText().equals("") ||
        tgewicht.getText().equals("") || !tleistung.getText().matches("[\\d]*") ||
        !tenergie.getText().matches("[\\d]*") ||
        !tgewicht.getText().matches("[\\d]*")) {
      Warnung w = new Warnung("Bitte vollstndig und gltig ausfllen!");
      fehler = true;
    }
    ResultSet result;
    result = db.select("select name from roboter");
    if (andernid == 0 || !tname.getText().equals(altername)) {
      try {
        while (result.next()) {
          if (result.getString("name").equals(tname.getText())) {
            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
      catch (SQLException ex) {
        System.out.println("Problem" + ex);
      }
    }

    if (!fehler) {
      ResultSet aresult;
      String aid = new String();
      try {
        aresult = db.select("select aid from antrieb where name='" +
                            antriebe.getSelectedItem() + "'");
        aresult.next();
        aid = aresult.getString("aid");
      }

      catch (SQLException ex) {
        System.out.println("Problem" + ex);
      }
      //einfgen der eingetragenen Werte bei neuanzulegendem Roboter
      if (andernid == 0) {
        String stmt = new String("insert into roboter (name, aid, gewicht, sendereichweite, energievorrat, bild) values" +
                                 "('" + tname.getText() + "', '" + aid + "', '" +
                                 tgewicht.getText() + "', '" +
                                 tleistung.getText() +
                                 "', '" + tenergie.getText() +
                                 "', '" + tbild.getText() +
                                 "') ");
        db.mach(stmt);
      }
      else {
        String stmt = new String("update roboter set name='" + tname.getText() +
                                 "' ,aid='" + aid + "', gewicht='" +
                                 tgewicht.getText() + "', sendereichweite='" +
                                 tleistung.getText() + "', energievorrat='" +
                                 tenergie.getText() + "',  bild='" +
                                 tbild.getText() + "' where rid='" + andernid +
                                 "'");
        db.mach(stmt);
      }

      String[] sensoren = new String[lsensoren.getItems().length];
      sensoren = lsensoren.getItems();
      ResultSet rresult;
      String rid = new String("");
      try {
        rresult = db.select("select rid from roboter where name='" +
                            tname.getText() + "'");
        rresult.next();
        rid = rresult.getString("rid");
      }

      catch (SQLException ex) {
        System.out.println("Problem" + ex);
      }
      String sid = new String("");
      ResultSet sresult;
      //beim ndern aktuallisieren der Werte in der Sensortabelle und berschreiben der Werte in der Roboter-Sensor-Zuordnung
      if (andernid != 0) {
        sresult=db2.select("select sensor.sid from sensor,umgsensorz where sensor.sid=umgsensorz.sid and umgsensorz.uid='"+Editor.getumgebung()+"'");
        try {
          while (sresult.next()) {
            db.mach("delete from rszuordnung where rid='" + andernid + "' and sid='" + sresult.getString("sid") + "'");
          }
        }
        catch (SQLException ex1) {
          System.out.println(ex1);
        }
      }
      for (int i = 0; i < lsensoren.getItems().length; i++) {

        try {
          sresult = db.select("select sid from sensor where name='" +
                              lsensoren.getItems()[i] + "'");
          sresult.next();
          sid = sresult.getString("sid");
        }

        catch (SQLException ex) {
          System.out.println("Problem" + ex);
        }
        db.mach("insert into rszuordnung (rid, sid) values ('" + rid + "','" +
                sid + "')");

      }

    }

  }

  void bbild_mouseClicked(MouseEvent e) {
    FileDialog d = new FileDialog(this, "Bild ffnen", FileDialog.LOAD);
    d.setFile("*.gif");
    d.setVisible(true);
    tbild.setText(d.getDirectory() + d.getFile());

  }

  void bsensor_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    String[] sensorlist = new String[lsensoren.getItems().length];
    sensorlist = lsensoren.getItems();
    for (int i = 0; i < lsensoren.getItems().length; i++) {
      if (sensorlist[i] == csensoren.getSelectedItem()) {
        fehler = true;
      }
    }
    if (!fehler) {
      lsensoren.add(csensoren.getSelectedItem());
    }
    lsensoren.repaint();
  }

  void bsensordel_actionPerformed(ActionEvent e) {
    if (lsensoren.getSelectedItem() != null) {
      lsensoren.remove(lsensoren.getSelectedItem());
    }
  }

}

class robotergui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Robotergui adaptee;

  robotergui_babbrechen_actionAdapter(Robotergui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class robotergui_beintragen_actionAdapter
    implements java.awt.event.ActionListener {
  Robotergui adaptee;

  robotergui_beintragen_actionAdapter(Robotergui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.beintragen_actionPerformed(e);
  }
}

class robotergui_bbild_mouseAdapter
    extends java.awt.event.MouseAdapter {
  Robotergui adaptee;

  robotergui_bbild_mouseAdapter(Robotergui adaptee) {
    this.adaptee = adaptee;
  }

  public void mouseClicked(MouseEvent e) {
    adaptee.bbild_mouseClicked(e);
  }
}

class robotergui_bsensor_actionAdapter
    implements java.awt.event.ActionListener {
  Robotergui adaptee;

  robotergui_bsensor_actionAdapter(Robotergui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bsensor_actionPerformed(e);
  }
}

class robotergui_bsensordel_actionAdapter
    implements java.awt.event.ActionListener {
  Robotergui adaptee;

  robotergui_bsensordel_actionAdapter(Robotergui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bsensordel_actionPerformed(e);
  }
}
