package editor;

import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;

/**
 * Maske zum ndern und Erstellen von Sensoren
 */
public class Sensorgui
    extends Frame {
  //Herstellen der bentigten Datenbankverbindugen
  Sql db = new Sql();
  Sql db2 = new Sql();

  String altername = new String();
  int andernid = 0; //id des zu ndernden Sensors, 0 bei neuem Datensatz
  Panel main = new Panel(null);
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label6 = new Label();
  TextField tname = new TextField();
  TextField tgewicht = new TextField();
  TextField tenergiez = new TextField();
  TextField tenergies = new TextField();
  TextField tebenen = new TextField();
  Choice ebenen = new Choice();
  sensorbild sb = new sensorbild();

  Label label7 = new Label();
  Label label8 = new Label();
  Label label9 = new Label();
  Label label10 = new Label();
  Button babbrechen = new Button();
  Button beintragen = new Button();

  /**
   * Konstruktor zum anlegen eines neuen Sensors
   */

  public Sensorgui() {
    super("Neuer Sensor");
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });
    main.setVisible(true);
    setVisible(true);
    this.setResizable(false);
  }

  /**
   * Konstruktor zum ndern eines vorhandenen Sensors
   * @param zuandern Name des zu ndernden Sensors
   */

  public Sensorgui(String zuandern) {
    super("Sensor ndern");
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    label1.setText("Sensor ndern");
    tname.setText(zuandern);
    altername = zuandern;
    beintragen.setLabel("ndern");
    //auslesen des vorhandenen Datensatzes
    ResultSet altedaten = db.select("select * from sensor where name='" +
                                    zuandern + "'");
    try {
      altedaten.next();
      andernid = altedaten.getInt("sid");
      tgewicht.setText(altedaten.getString("gewicht"));
      tenergiez.setText(altedaten.getString("grundenergie"));
      tenergies.setText(altedaten.getString("scanenergie"));
      tebenen.setText(altedaten.getString("anzahlebenen"));
      for (int i = 1; i <= Integer.parseInt(tebenen.getText()); i++) {
        ebenen.add(String.valueOf(i));
      }
    }
    catch (SQLException ex) {
    }
    ebenen.validate();
    altedaten = db.select("select * from schablonenkachel where sid='" +
                          andernid + "'");
    try {
      while (altedaten.next()) {
        schablone[altedaten.getInt("x")][altedaten.getInt("y")] = altedaten.
            getString("sichtbereich");
      }
    }
    catch (SQLException ex1) {
    }

    ResultSet gidresult;
    gidresult = db2.select("select gelaende.gid from gelaende ,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                           Editor.getumgebung() + "'");
    int i = 0;
    try {
      while (gidresult.next()) {
        altedaten = db.select("select * from durchsichtigkeit where sid='" +
                              andernid + "' and gid='" +
                              gidresult.getString("gid") + "'");

        while (altedaten.next()) {
          ( (TextField) ergebnisse[i][0]).setText(altedaten.getString(
              "scandauer"));
          ( (Checkbox) ergebnisse[i][1]).setState(altedaten.getBoolean(
              "durchsichtigkeit"));
          i++;
        }
      }

    }
    catch (SQLException ex1) {
      System.out.println(ex1);
    }

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });
    main.setVisible(true);
    setVisible(true);
    this.setResizable(false);
  }

  public static void main(String[] args) {
    Sensorgui s = new Sensorgui("Sonar");
    s.setVisible(true);
  }

  private Object[][] ergebnisse;
  int anzahlgelaende;
  private String[] gelaendetypen;
  private String[][] schablone = new String[21][21]; // Array fr den Sichtbarkeitsbereich und die Sensorebenen
  private boolean[][] scannbar = new boolean[21][21]; // Array zum Ausblenden der Ecken, damit es beim spteren rotieren keine Probleme gibt
  TextField tstdauer = new TextField();
  Button bstdauer = new Button();
  Label label11 = new Label();

  private void jbInit() throws Exception { //Aufbauen der Eingabemaske
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Neuen Sensor anlegen");
    label1.setBounds(new Rectangle(250, 25, 187, 29));
    this.setLayout(null);
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Name:");
    label2.setBounds(new Rectangle(26, 60, 104, 26));
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setText("Gewicht:");
    label3.setBounds(new Rectangle(26, 85, 104, 26));
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    label4.setText("Energie / Zeit:");
    label4.setBounds(new Rectangle(26, 110, 104, 26));
    label5.setFont(new java.awt.Font("Dialog", 0, 13));
    label5.setText("Energie / Scan:");
    label5.setBounds(new Rectangle(26, 135, 104, 26));
    label6.setFont(new java.awt.Font("Dialog", 0, 13));
    label6.setText("#Sensorebenen:");
    label6.setBounds(new Rectangle(26, 160, 104, 26));
    tname.setText("");
    tname.setBounds(new Rectangle(154, 60, 143, 22));
    tgewicht.setText("");
    tgewicht.setBounds(new Rectangle(154, 85, 99, 22));
    tenergiez.setText("");
    tenergiez.setBounds(new Rectangle(154, 110, 99, 22));
    tenergies.setText("");
    tenergies.setBounds(new Rectangle(154, 135, 99, 22));
    tebenen.setText("0");
    tebenen.setBounds(new Rectangle(154, 160, 99, 22));
    tebenen.addFocusListener(new Sensorgui_tebenen_focusAdapter(this));

    for (int i = 1;
         new Integer(i).compareTo(Integer.valueOf(tebenen.getText())) < 0; i++) {
      ebenen.add("i");
    }
    label7.setFont(new java.awt.Font("Dialog", 0, 13));
    label7.setText("aktuelle Sensorebene:");
    label7.setBounds(new Rectangle(26, 185, 135, 18));
    this.setBackground(SystemColor.menu);
    label8.setText("Gelndearten");
    label8.setBounds(new Rectangle(350, 90, 87, 26));
    label8.setFont(new java.awt.Font("Dialog", 0, 13));
    label9.setText("Scandauer");
    label9.setBounds(new Rectangle(455, 90, 84, 26));
    label9.setFont(new java.awt.Font("Dialog", 0, 13));
    label10.setText("Durchsichtigkeit");
    label10.setBounds(new Rectangle(530, 90, 130, 26));
    label10.setFont(new java.awt.Font("Dialog", 0, 13));
    babbrechen.setLabel("Abbrechen");
    babbrechen.setBounds(new Rectangle(46, 572, 111, 30));
    babbrechen.addActionListener(new Sensorgui_babbrechen_actionAdapter(this));
    beintragen.setLabel("Eintragen");
    beintragen.setBounds(new Rectangle(208, 571, 111, 30));
    beintragen.addActionListener(new Sensorgui_beintragen_actionAdapter(this));
    tstdauer.setText("");
    tstdauer.setBounds(new Rectangle(486, 60, 99, 22));
    bstdauer.setLabel("Standarddauer:");
    bstdauer.setBounds(new Rectangle(350, 59, 129, 25));
    bstdauer.addActionListener(new Sensorgui_bstdauer_actionAdapter(this));
    ebenen.setBounds(new Rectangle(165, 185, 88, 22));
    sb.setBounds(new Rectangle(22, 220, 320, 340));
    ebenen.add("");

    main.add(label1, null);
    main.add(label2, null);
    main.add(label4, null);
    main.add(label5, null);
    main.add(label6, null);
    main.add(label3, null);
    main.add(tname, null);
    main.add(tgewicht, null);
    main.add(tenergiez, null);
    main.add(tenergies, null);
    main.add(tebenen, null);
    main.add(label7, null);
    main.add(ebenen, null);
    main.add(label8, null);
    main.add(label10, null);
    main.add(label9, null);
    main.add(babbrechen, null);
    main.add(beintragen, null);
    main.add(bstdauer, null);
    main.add(tstdauer, null);
    main.add(label11, null);
    main.add(sb, null);

    main.resize(650, 620);
    this.add(main);

    ResultSet result;
    result = db.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                       Editor.getumgebung() + "'");
    result.last();
    anzahlgelaende = result.getRow();
    result.beforeFirst();
    int i = 1;
    ergebnisse = new Object[anzahlgelaende][3];
    gelaendetypen = new String[anzahlgelaende];
    // bestimmen welche Felder im Scannbaren Bereich sind und Eintragen ins Scannbararray
    for (int k = 0; k < 21; k++) {
      for (int j = 0; j < 21; j++) {
        if ( (k < 2 && j < 6) || (k < 2 && j > 14) || (k < 6 && j < 2) ||
            (k > 14 && j < 2) || (k < 4 && j > 16) || (k > 16 && j < 4) ||
            (k < 4 && j < 4) || (k > 16 && j > 16) ||(k > 18 && j > 14) ||
            (k > 14 && j > 18)|| (k > 18 && j < 6) || (k < 6 && j > 18)) {
          scannbar[k][j] = false;
        }
        else {
          scannbar[k][j] = true;
        }
      }
    }


    try {
      while (result.next()) {
        Label l = new Label(result.getString("name"));
        gelaendetypen[i - 1] = result.getString("name");
        TextField energie = new TextField();
        Checkbox passbar = new Checkbox();
        TextField meldung = new TextField();
        ergebnisse[i - 1][0] = energie;
        ergebnisse[i - 1][1] = passbar;
        main.add(l);
        l.setBounds(new Rectangle(350, i * 20 + 100, 85, 20));
        main.add( (Component) (ergebnisse[i - 1][0]));
        ( (Component) (ergebnisse[i - 1][0])).setBounds(new Rectangle(455,
            i * 20 + 100, 85, 20));
        main.add( (Component) (ergebnisse[i - 1][1]));
        ( (Component) (ergebnisse[i - 1][1])).setBounds(new Rectangle(565,
            i * 20 + 100, 85, 20));
        i++;
      }
      if (i > 22) {
        this.resize(650, 130 + i * 20);
      }
      else {
        this.resize(650, 620);
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem" + ex);
    }

  }

  class sensorbild  //diese Klasse beinhaltet das Erstellen des Sensorenbereiches (links unten)
      extends Canvas {

    public sensorbild() {
      this.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent e) {
          int x = (e.getX() - e.getX() % 15) / 15;
          int y = ( (e.getY() - e.getY() % 15) / 15) * -1 +
              21 - 1;

          if (x >= 0 && x < 21 && y >= 0 && y < 21 && scannbar[x][y]) {
            schablone[x][20 - y] = ebenen.getSelectedItem();
          }
          repaint();
        }
      });
      this.setVisible(true);
    }

    public void paint(Graphics g) {

      int i = 0;
      g.drawLine(90, 0, 225, 0);
      g.drawLine(90, 15, 225, 15);
      g.drawLine(60, 30, 255, 30);
      g.drawLine(60, 45, 255, 45);
      g.drawLine(30, 60, 285, 60);
      g.drawLine(30, 75, 285, 75);
      for (i = 6; i <= 15; i++) { // Horizontale Linien
        g.drawLine(1, i * 15, 315, i * 15);
      }
      g.drawLine(30, 240, 285, 240);
      g.drawLine(30, 255, 285, 255);
      g.drawLine(60, 270, 255, 270);
      g.drawLine(60, 285, 255, 285);
      g.drawLine(90, 300, 225, 300);
      g.drawLine(90, 315, 225, 315);

      g.drawLine(0, 90, 0, 225);
      g.drawLine(15, 90, 15, 225);
      g.drawLine(30, 60, 30, 255);
      g.drawLine(45, 60, 45, 255);
      g.drawLine(60, 30, 60, 285);
      g.drawLine(75, 30, 75, 285);

      for (i = 6; i <= 15; i++) { // Vertikale Linien
        g.drawLine(i * 15, 1, i * 15, 315);
      }

      g.drawLine(240, 30, 240, 285);
      g.drawLine(255, 30, 255, 285);
      g.drawLine(270, 60, 270, 255);
      g.drawLine(285, 60, 285, 255);
      g.drawLine(300, 90, 300, 225);
      g.drawLine(315, 90, 315, 225);

      g.setColor(Color.red);
      g.drawRect(150, 150, 15, 15);
      g.drawString("R", 153, 163);
      g.setColor(Color.black);

      int x, y;
      y = -1;
      while (y < 20) {
        y++;
        x = -1;
        while (x < 20) {
          x++;
          if (schablone[x][y] == "") {
            schablone[x][y] = null;
          }
          if (schablone[x][y] != null &&
              Integer.valueOf(schablone[x][y]).
              compareTo(Integer.valueOf(tebenen.getText())) > 0) {
            schablone[x][y] = null;
          }
          if (schablone[x][y] != null) {
            g.drawString("" + schablone[x][y], x * 15 + 5, y * 15 + 13);
          }
        }

      }

    }

  }

  void tebenen_focusLost(FocusEvent e) {
    if (tebenen.getText().matches("[\\d]*")) {
      ebenen.removeAll();
      for (int i = 1;
           new Integer(i).compareTo(Integer.valueOf(tebenen.getText())) <= 0; i++) {
        ebenen.add(String.valueOf(i));
      }
      ebenen.add("");
      ebenen.repaint();
      sb.repaint();
    }
    else {
      Warnung w = new Warnung("Fr die Ebenenanzahl sind nur Zahlen zulssig!");
    }
  }

  void babbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    //berprfung der eingetragenen Werte
    if (tname.getText().equals("") || tebenen.getText().equals("") ||
        tenergies.getText().equals("") || tenergiez.getText().equals("") ||
        tgewicht.getText().equals("") || !tebenen.getText().matches("[\\d]*") ||
        !tenergies.getText().matches("[\\d]*") ||
        !tenergiez.getText().matches("[\\d]*") ||
        !tgewicht.getText().matches("[\\d]*")) {
      Warnung w = new Warnung("Bitte vollstndig und gltig ausfllen!");
      fehler = true;
    }
    for (int i = 0; i < anzahlgelaende; i++) {
      if (! ( (TextField) ergebnisse[i][0]).getText().matches("[\\d]*")) {
        fehler = true;
        Warnung w = new Warnung("Fr die Scandauer sind nur Zahlen zulssig!");
      }
    }
    ResultSet result;
    result = db.select("select name from sensor");
    if (andernid == 0 || !altername.equals(tname.getText())) {
      try {
        while (result.next()) {
          if (result.getString("name").equals(tname.getText())) {

            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
      catch (SQLException ex) {
        System.out.println("Problem" + ex);
      }
    }
    if (!fehler) {
      // einfgen der Datenstze beim Neuanlegen eines Sensors
      if (andernid == 0) {
        String stmt = new String("insert into sensor (name, gewicht, grundenergie, scanenergie, anzahlebenen) values" +
                                 "('" + tname.getText() + "', '" +
                                 tgewicht.getText() +
                                 "', '" + tenergiez.getText() + "', '" +
                                 tenergies.getText() + "', '" + tebenen.getText() +
                                 "') ");
        db.mach(stmt);
      }

      else {
         // berschreiben der alten Werte, wenn gendert werden soll
         String stmt = new String("update sensor set name='" + tname.getText() +
                                 "', gewicht='" + tgewicht.getText() +
                                 "', grundenergie='" + tenergiez.getText() +
                                 "', scanenergie='" + tenergies.getText() +
                                 "', anzahlebenen='" + tebenen.getText() +
                                 "' where sid='" + andernid + "' ");
        db.mach(stmt);
      }
      // neu schreiben der Eintrge aus Kachel- und Durchsichtigkeitstabelle
      if (andernid != 0) {
        db.mach("delete from schablonenkachel where sid='" + andernid + "'");
        ResultSet gidresult;
        gidresult = db2.select("select gelaende.gid from gelaende ,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='" +
                               Editor.getumgebung() + "'");
        try {
          while (gidresult.next()) {
            db.mach("delete from durchsichtigkeit where sid='" + andernid +
                    "'and gid='" + gidresult.getString("gid") + "'");
          }
        }
        catch (SQLException ex2) {
          System.out.println(ex2);
        }

      }

      String gid = new String();
      String sid = new String();
      int i = 0;
      int j = 0;
      ResultSet sidres;
      sidres = (db.select("select sid from sensor where name ='" +
                          tname.getText() + "'"));
      try {
        sidres.next();
        sid = sidres.getString("sid");
      }
      catch (SQLException ex1) {
        System.out.println("Problem bei sidholen" + ex1);
        fehler = true;
      }

      if (!fehler) {
        for (i = 0; i < anzahlgelaende; i++) {
          ResultSet gidres;
          gidres = (db.select("select gid from gelaende where name='" +
                              gelaendetypen[i] + "'"));
          try {
            gidres.next();
            gid = gidres.getString("gid");
          }
          catch (SQLException ex) {
            System.out.println("Problem bei gidholen" + ex);
          }

          db.mach(
              "insert into durchsichtigkeit (sid, gid, scandauer, durchsichtigkeit)values ('" +
              sid + "','" + gid + "','" +
              ( (TextField) ergebnisse[i][0]).getText() + "','" +
              ( (Checkbox) ergebnisse[i][1]).getState() + "')");
        }
        // eintragen der Schablonenkacheln
        int x, y;
        y = -1;
        while (y < 20) {
          y++;
          x = -1;
          while (x < 20) {
            x++;

            if (schablone[x][y] != null && schablone[x][y] != "") {
              db.mach(
                  "insert into schablonenkachel (sid, x, y, sichtbereich) values('" +
                  sid + "','" +
                  x + "','" + y + "','" + schablone[x][y] + "')");

            }
          }
        }

      }

    }
  }

  void bstdauer_actionPerformed(ActionEvent e) {
    for (int i = 1; i <= anzahlgelaende; i++) {
      ( (TextField) ergebnisse[i - 1][0]).setText(tstdauer.getText());
    }

  }

}

class Sensorgui_tebenen_focusAdapter
    extends java.awt.event.FocusAdapter {
  Sensorgui adaptee;

  Sensorgui_tebenen_focusAdapter(Sensorgui adaptee) {
    this.adaptee = adaptee;
  }

  public void focusLost(FocusEvent e) {
    adaptee.tebenen_focusLost(e);
  }
}

class Sensorgui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Sensorgui adaptee;

  Sensorgui_babbrechen_actionAdapter(Sensorgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class Sensorgui_beintragen_actionAdapter
    implements java.awt.event.ActionListener {
  Sensorgui adaptee;

  Sensorgui_beintragen_actionAdapter(Sensorgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.beintragen_actionPerformed(e);
  }
}

class Sensorgui_bstdauer_actionAdapter
    implements java.awt.event.ActionListener {
  Sensorgui adaptee;

  Sensorgui_bstdauer_actionAdapter(Sensorgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bstdauer_actionPerformed(e);
  }
}