package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.*;
import java.util.Vector;
import agent.AgentLoader;
import gameserver.Roboter;
import agent.Agent;
import java.util.Enumeration;
import java.util.EventListener;

/**
 * Maske fr das Erstellen der Einstellungen einer Simulation
 */

public class Simstartgui
    extends Panel {

  Sql db = new Sql();

  XYLayout xYLayout1 = new XYLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  TextField tname = new TextField();
  Checkbox cbminen = new Checkbox();
  Checkbox cbhoehen = new Checkbox();
  Checkbox cbrobbis = new Checkbox();
  Choice czoom = new Choice();
  Choice cspielfeld = new Choice();
  Label label6 = new Label();
  Label label7 = new Label();
  Label label8 = new Label();
  Choice crobbis = new Choice();
  Choice cblick = new Choice();
  TextField trobotername = new TextField();
  List lroboter = new List();
  Button bentfernen = new Button();
  Button beinfuegen = new Button();
  Label label9 = new Label();
  Button babbrechen = new Button();
  Button bsimulieren = new Button();
  ScrollPane spfeldhalter = new ScrollPane();
  Spielfeld sp;
  Checkbox cbgelaende = new Checkbox();

  Vector roboterVector = new Vector();
  Vector robNameTypKombis = new Vector();
  Label label10 = new Label();
  Choice cagenten = new Choice();

  public Simstartgui() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  // Mainmethode zu Testzwecken
  public static void main(String[] args) {
    Frame f = new Frame();

    f.setSize(Toolkit.getDefaultToolkit().getScreenSize());
    Simstartgui simgui = new Simstartgui();
    f.add(simgui);
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
    f.show();

  }

  private void jbInit() throws Exception { //malen der Maske
    bsimulieren.setFont(new java.awt.Font("Dialog", 0, 13));
    babbrechen.setFont(new java.awt.Font("Dialog", 0, 13));
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Simulationseinstellungen");
    this.setBackground(SystemColor.control);
    this.setLayout(xYLayout1);
    label2.setEnabled(true);
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Simulationsname:");
    label3.setText("Spielfeld:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setEnabled(true);
    label4.setEnabled(true);
    label4.setFont(new java.awt.Font("Dialog", 0, 13));
    label4.setText("%");
    label5.setFont(new java.awt.Font("Dialog", 0, 13));
    label5.setText("Anzeigen:");
    tname.setText("");
    cbminen.setFont(new java.awt.Font("Dialog", 0, 13));
    cbminen.setLabel("Minen");
    cbminen.setState(true);
    cbminen.addItemListener(new Simstartgui_cbminen_itemAdapter(this));
    cbhoehen.setFont(new java.awt.Font("Dialog", 0, 13));
    cbhoehen.setLabel("Hhen");
    cbhoehen.setState(true);
    cbhoehen.addItemListener(new Simstartgui_cbhoehen_itemAdapter(this));
    cbrobbis.setFont(new java.awt.Font("Dialog", 0, 13));
    cbrobbis.setLabel("Roboter");
    cbrobbis.setState(true);
    cbrobbis.addItemListener(new Simstartgui_cbrobbis_itemAdapter(this));
    xYLayout1.setWidth(1225);
    xYLayout1.setHeight(365);
    label6.setText("Roboter:");
    label6.setFont(new java.awt.Font("Dialog", 0, 13));
    label6.setEnabled(true);
    label7.setText("Robotertyp:");
    label7.setFont(new java.awt.Font("Dialog", 0, 13));
    label7.setEnabled(true);
    label8.setText("Robotername:");
    label8.setFont(new java.awt.Font("Dialog", 0, 13));
    label8.setEnabled(true);
    trobotername.setText("");
    bentfernen.setFont(new java.awt.Font("Dialog", 0, 13));
    bentfernen.setLabel("Entfernen");
    bentfernen.addActionListener(new Simstartgui_bentfernen_actionAdapter(this));
    beinfuegen.setFont(new java.awt.Font("Dialog", 0, 13));
    beinfuegen.setLabel("Roboter einfgen");
    beinfuegen.addActionListener(new Simstartgui_beinfuegen_actionAdapter(this));
    label9.setText("Blickrichtung:");
    label9.setFont(new java.awt.Font("Dialog", 0, 13));
    label9.setEnabled(true);
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new Simstartgui_babbrechen_actionAdapter(this));
    bsimulieren.setLabel("Simulieren");
    bsimulieren.addActionListener(new Simstartgui_bsimulieren_actionAdapter(this));

    cspielfeld.addItemListener(new Simstartgui_cspielfeld_itemAdapter(this));
    czoom.addItemListener(new Simstartgui_czoom_itemAdapter(this));
    cbgelaende.setLabel("Gelnde");
    cbgelaende.setState(true);
    cbgelaende.addItemListener(new Simstartgui_cbgelaende_itemAdapter(this));
    label10.setEnabled(true);
    label10.setFont(new java.awt.Font("Dialog", 0, 13));
    label10.setText("Roboterhirn:");
    lroboter.addItemListener(new Simstartgui_lroboter_itemAdapter(this));
    czoom.add("25");
    czoom.add("50");
    czoom.add("75");
    czoom.add("100");
    czoom.add("125");
    czoom.add("150");
    czoom.select("100");

    cblick.add("Nord");
    cblick.add("Nordost");
    cblick.add("Ost");
    cblick.add("Sdost");
    cblick.add("Sd");
    cblick.add("Sdwest");
    cblick.add("West");
    cblick.add("Nordwest");
    //Fllen des Drop-Down-Mens fr die Agenten
    AgentLoader a = new AgentLoader();
    int length = a.loadAgentClassNamesValidate().length;
    String[] agenten = new String[length];
    agenten = a.loadAgentClassNamesValidate();
    for (int i = 0; i < length; i++) {
      if (agenten[i] != null) {
        cagenten.add(agenten[i]);
      }
    }

    ResultSet result;
    result = db.select("select name from spielfeld");
    try {
        cspielfeld.add("");
      while (result.next()) {
        cspielfeld.add(result.getString("name"));

      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Spielfeldpulldown " + ex);
    }

    result = db.select("select name from roboter");
    try {
      while (result.next()) {
        crobbis.add(result.getString("name"));

      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Roboterpulldown " + ex);
    }
    cspielfeld.add("");

    this.add(spfeldhalter,
             new XYConstraints(5, 110,
                               ( (int) Toolkit.getDefaultToolkit().
                                getScreenSize().
                                getWidth()) - 10,
                               ( (int) Toolkit.getDefaultToolkit().
                                getScreenSize().
                                getHeight()) - 140));
    this.add(label1, new XYConstraints(502, 2, 222, 33));
    this.add(bentfernen, new XYConstraints(445, 76, -1, -1));
    this.add(label7, new XYConstraints(671, 79, 73, 24));
    this.add(label9, new XYConstraints(861, 47, 83, 24));
    this.add(cblick, new XYConstraints(945, 47, 64, -1));
    this.add(label6, new XYConstraints(445, 47, 54, 24));
    this.add(beinfuegen, new XYConstraints(862, 76, 147, -1));
    this.add(lroboter, new XYConstraints(539, 39, 123, 64));
    this.add(label4, new XYConstraints(284, 81, 17, 24));
    this.add(cbhoehen, new XYConstraints(301, 80, 58, 18));
    this.add(cbrobbis, new XYConstraints(375, 80, -1, 18));
    this.add(bsimulieren, new XYConstraints(912, 8, 97, 23));
    this.add(babbrechen, new XYConstraints(805, 8, 98, 23));
    this.add(label2, new XYConstraints(12, 49, 105, 24));
    this.add(label5, new XYConstraints(213, 48, 62, 26));
    this.add(czoom, new XYConstraints(214, 80, 64, -1));
    this.add(tname, new XYConstraints(123, 50, 84, 23));
    this.add(cspielfeld, new XYConstraints(103, 80, 104, -1));
    this.add(label3, new XYConstraints(12, 80, 64, 24));
    this.add(crobbis, new XYConstraints(758, 84, 97, 19));
    this.add(cbminen, new XYConstraints(375, 57, 55, 18));
    this.add(cbgelaende, new XYConstraints(301, 57, 71, 18));
    this.add(label8, new XYConstraints(671, 35, 83, 24));
    this.add(trobotername, new XYConstraints(758, 36, 96, 19));
    this.add(label10, new XYConstraints(671, 57, 83, 24));
    this.add(cagenten, new XYConstraints(758, 59, 97, 19));

  }

  void cspielfeld_itemStateChanged(ItemEvent e) {
    if (Spielfeld.getspielfeld(cspielfeld.getSelectedItem()) == null) {
      sp = new Spielfeld(cspielfeld.getSelectedItem());
    }
    else {
      sp = Spielfeld.getspielfeld(cspielfeld.getSelectedItem());
    }
    sp.addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent e) { //abfangen der Klicks auf das Spiefeld zum Setzen der Roboter auf das Spielfeld

        int groesse = (Integer.valueOf(czoom.getSelectedItem()).intValue() /
                       5);
        int x = (e.getX() - e.getX() % groesse) / groesse;
        int y = ( (e.getY() - e.getY() % groesse) / groesse);

        Roboter[] robbis = new Roboter[sp.getroboter().length];
        robbis = sp.getroboter();
        boolean besetzt = false;
        for (int i = 0; i < sp.getroboter().length; i++) { //prft of auf Kachel schon ein Robbi steht
          if (robbis[i].getX() == x && robbis[i].getY() == y) {
            besetzt = true;
          }
        }

        if (x >= 0 && x < sp.getbreite() && y >= 0 && y < sp.getlaenge() &&
            lroboter.getSelectedItem() != null && !besetzt) {
          String robbiname = new String();
          robbiname = lroboter.getSelectedItem().substring(0,
              lroboter.getSelectedItem().indexOf(':'));
          Roboter robbi;
          if (sp.getRoboterByName(robbiname) == null) {
            robbi = loadRoboter(robbiname);
            sp.addroboter(robbi);
          }
          else {
            robbi = sp.getRoboterByName(robbiname);
          }
          robbi.setX(x);
          robbi.setY(y);
        }
        if (x >= 0 && x < sp.getbreite() && y >= 0 && y < sp.getlaenge() &&
            besetzt) { //angeklickten Robbi in Liste anwhlen
          String robbiname = new String();
          for (int i = 0; i < sp.getroboter().length; i++) {
            if (robbis[i].getX() == x && robbis[i].getY() == y) {

              String typName = robbis[i].gettypname();
              String instanzName = robbis[i].getName();
              for (int j = 0; j < lroboter.getItemCount(); j++) {
                robbiname = lroboter.getItems()[j].substring(0,
                    lroboter.getItems()[j].indexOf(':'));
                if (robbiname.equalsIgnoreCase(instanzName)) {
                  System.out.println("hallo" + j);
                  lroboter.select(j);
                }
              }

            }
          }

        }
        sp.repaint();
      }
    });

    spfeldhalter.add(sp);
    sp.setVisible(true);
    spfeldhalter.setVisible(true);
    spfeldhalter.doLayout();
  }

  void cbminen_itemStateChanged(ItemEvent e) {

    sp.setmit(cbgelaende.getState(), cbrobbis.getState(), cbhoehen.getState(),
              cbminen.getState());

  }

  void cbhoehen_itemStateChanged(ItemEvent e) {

    sp.setmit(cbgelaende.getState(), cbrobbis.getState(), cbhoehen.getState(),
              cbminen.getState());

  }

  void cbrobbis_itemStateChanged(ItemEvent e) {

    sp.setmit(cbgelaende.getState(), cbrobbis.getState(), cbhoehen.getState(),
              cbminen.getState());

  }

  void czoom_itemStateChanged(ItemEvent e) {
    sp.setzoom(Integer.parseInt(czoom.getSelectedItem()));
    spfeldhalter.doLayout();
  }

  void cbgelaende_itemStateChanged(ItemEvent e) {

    sp.setmit(cbgelaende.getState(), cbrobbis.getState(), cbhoehen.getState(),
              cbminen.getState());

  }

  void babbrechen_actionPerformed(ActionEvent e) {
    this.getParent().remove(this);
  }

  void beinfuegen_actionPerformed(ActionEvent e) {

    String instanzName = trobotername.getText();
    String blickrichtung = cblick.getSelectedItem();
    String typName = crobbis.getSelectedItem();
    String agentName = cagenten.getSelectedItem();
    log("instanzName: " + instanzName + "\n blickrichtung: " + blickrichtung +
        "\n typName: " + typName + "\nAgentName: " + agentName);

    boolean fehler = false;
    String[] roboterlist = new String[lroboter.getItems().length];
    roboterlist = lroboter.getItems();
    for (int i = 0; i < lroboter.getItems().length; i++) {
      if (roboterlist[i].substring(0,
          roboterlist[i].indexOf(':')).equals(trobotername.getText()))
      fehler = true;
    }

    if (trobotername.getText().equals("")) {
      fehler = true;
    }

    if (!fehler) {

      robNameTypKombis.add(new RobNameTypKombi(instanzName, typName, agentName));
      lroboter.add(instanzName + ": " + typName);
      lroboter.validate();
    }

  }




    private void showErrorDialog(String errorMessage){

        FehlerDialog f = new FehlerDialog((Frame) this.getParent(), "Fehler");
        f.setErrorText(errorMessage);
        f.setVisible(true);

    }

  void log(String message) {
    System.out.println("Simstartgui: " + message);
  }

  void bentfernen_actionPerformed(ActionEvent e) {
    int id = lroboter.getSelectedIndex();
    robNameTypKombis.remove(id);
    lroboter.remove(id);
    lroboter.validate();
    log("" + id);
  }



  void bsimulieren_actionPerformed(ActionEvent e) {
    //berprfen der eingegebenen Einstellungen
    String spielfeldname = cspielfeld.getSelectedItem();
    if (spielfeldname.equals("")) {
        // ist das Spielfeld berhaupt geladen?
        showErrorDialog("Bitte das Spielfeld laden!");
        return;
    } else if(tname.getText().equals("")){
            // Hat die Simulation einen Namen?
            showErrorDialog("Bitte einen Namen fr diese Simulation eingeben!");
            return;
    } else if(robNameTypKombis.size() == 0){
            // mind ein Rob gesetzt?
            showErrorDialog("Bitte mindestens einen Roboter einrichten!");
            // fr jeden Rob ein Name wird beim Eingeben bereits abgefangen
            return;
    } else if (sp == null){
        // prfe, ob Spielfeld geladen ist
        showErrorDialog("Bitte das Spielfeld laden!");
        return;
    } else {
       // Roboter werden erst dann geladen, wenn sie auf dem Spielfeld gesetzt sind

       Roboter[] gesetzteRobbies = sp.getroboter();
       if(gesetzteRobbies.length < robNameTypKombis.size()){
            showErrorDialog("Bitte alle Roboter auf dem Feld setzen!");
           return;
       }


    } // Ende else

      EventListener[] listeners = sp.getListeners(MouseListener.class);
      for (int i = 0; i < listeners.length; i++){
          sp.removeMouseListener((MouseListener)listeners[i]);
      }

      SimulationGUI simgui = new SimulationGUI();
      this.getParent().add(simgui);
      simgui.setTopEditorFrame((Frame) this.getParent());
      simgui.initSimulation(sp);
      this.getParent().remove(this);
      simgui.setVisible(true);
      simgui.getParent().setVisible(true);

  }  // Ende b_simulieren..... (Simulationsstart)


  /**
   * laden eines Roboters
   * @param name Name des zu ladenden Roboters
   * @return fertig geladenes Roboterobjekt
   */
  public Roboter loadRoboter(String name) {
    Enumeration enum = roboterVector.elements();
    Spielfeld spielfeld = Spielfeld.getspielfeld(cspielfeld.getSelectedItem());
    Roboter roboter = null;
    while (enum.hasMoreElements()) {
      Roboter r = (Roboter) enum.nextElement();
      if (r.getName().equals(name)) {
        roboter = r;
      }
    }
    if (roboter == null) {
      log("" + lroboter.getItemCount() + ", " + robNameTypKombis.size());

      RobNameTypKombi r = (RobNameTypKombi) robNameTypKombis.get(lroboter.getSelectedIndex());
      RoboterTyp typ = RoboterTyp.loadRoboterTyp( r.getTyp());
      roboter = new Roboter(typ, name, spielfeld);
      roboter.setAgentenName(r.getAgentName());

    }
    if (cblick.getSelectedItem().equals("Nord")) {
      roboter.turn(0, -1);
    }
    else if (cblick.getSelectedItem().equals("Nordost")) {
      roboter.turn(1, -1);
    }
    else if (cblick.getSelectedItem().equals("Ost")) {
      roboter.turn(1, 0);
    }
    else if (cblick.getSelectedItem().equals("Sdost")) {
      roboter.turn(1, 1);
    }
    else if (cblick.getSelectedItem().equals("Sd")) {
      roboter.turn(1, 0);
    }
    else if (cblick.getSelectedItem().equals("Sdwest")) {
      roboter.turn( -1, -1);
    }
    else if (cblick.getSelectedItem().equals("West")) {
      roboter.turn( -1, 0);
    }
    else if (cblick.getSelectedItem().equals("Nordwest")) {
      roboter.turn( -1, -1);

    }

    return roboter;
  }

  void lroboter_itemStateChanged(ItemEvent e) {
    String robbiname = new String();
    robbiname = lroboter.getSelectedItem().substring(0,
        lroboter.getSelectedItem().indexOf(':'));
    System.out.println(robbiname);

    Roboter robbi = null;
    robbi = loadRoboter(robbiname);
    trobotername.setText(robbiname);
    cagenten.select(robbi.getAgentenName());
    System.out.println(robbi.getAgentenName() + "-" + robbi.gettypname() +
                       "-" +
                       robbi.getBlickRichtung());
    crobbis.select(robbi.gettypname());
    cblick.select(robbi.getBlickRichtung());
  }

}

class Simstartgui_cspielfeld_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_cspielfeld_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cspielfeld_itemStateChanged(e);
  }
}

class Simstartgui_cbminen_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_cbminen_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbminen_itemStateChanged(e);
  }
}

class Simstartgui_cbhoehen_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_cbhoehen_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbhoehen_itemStateChanged(e);
  }
}

class Simstartgui_cbrobbis_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_cbrobbis_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbrobbis_itemStateChanged(e);
  }
}

class Simstartgui_czoom_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_czoom_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.czoom_itemStateChanged(e);
  }
}

class Simstartgui_cbgelaende_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_cbgelaende_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbgelaende_itemStateChanged(e);
  }
}

class Simstartgui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Simstartgui adaptee;

  Simstartgui_babbrechen_actionAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class Simstartgui_beinfuegen_actionAdapter
    implements java.awt.event.ActionListener {
  Simstartgui adaptee;
  Simstartgui_beinfuegen_actionAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.beinfuegen_actionPerformed(e);

  }
}

class Simstartgui_bentfernen_actionAdapter
    implements java.awt.event.ActionListener {
  Simstartgui adaptee;
  Simstartgui_bentfernen_actionAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bentfernen_actionPerformed(e);

  }
}

class Simstartgui_bsimulieren_actionAdapter
    implements java.awt.event.ActionListener {
  Simstartgui adaptee;
  Simstartgui_bsimulieren_actionAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bsimulieren_actionPerformed(e);

  }
}
/**
 * Diese Klasse ist quasi ein Record in dem die Einzelteile des Roboters enthalten sind
 */
class RobNameTypKombi {
  String name; //Name des Roboters
  String typ;  //Der Robotertyp ist der Name des Roboters aus der Datenbank, also Stammdaten wie Antrieb, Sensoren, eigene Attribute
  String agent; // der Name des das Roboterhirn enthaltenden Javaklasse

  /**
   * Konstruktor zum erstellen eines neuen Datensatzes
   * @param name Name des Roboters
   * @param typ  Der Robotertyp ist der Name des Roboters aus der Datenbank, also Stammdaten wie Antrieb, Sensoren, eigene Attribute
   * @param agent der Name des das Roboterhirn enthaltenden Javaklasse
   */
  public RobNameTypKombi(String name, String typ, String agent) {
    this.name = name;
    this.typ = typ;
    this.agent = agent;

  }
  /**
   * liefert den Namen dieses Roboterdatensatzes
   * @return Name dieses Roboterdatensatzes
   */
  public String getName() {
    return name;
  }

  /**
   * liefert den Namen des Typs dieses Roboterdatensatzes
   * @return Name es Typs dieses Roboterdatensatzes
   */
  public String getTyp() {
    return typ;
  }

   /**
   * liefert den Namen der Javaklasse des Hirns dieses Roboterdatensatzes
   * @return Name der Javaklasse des Hirns dieses Roboterdatensatzes
   */
    public String getAgentName() {
        return agent;
    }
}

class Simstartgui_lroboter_itemAdapter
    implements java.awt.event.ItemListener {
  Simstartgui adaptee;

  Simstartgui_lroboter_itemAdapter(Simstartgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.lroboter_itemStateChanged(e);
  }



}

 /**
  * erstellt ein Fenster mit einer Fehlermeldung und einer OK-Taste zum besttigen
  */
 class FehlerDialog extends Dialog implements java.awt.event.ActionListener{

     private Button b1 = new Button("OK");
     private Panel p1 = new Panel();
     private Panel p2 = new Panel();

     /**
      * Konstruktor des Fehlerdialogs
      * @param owner bergeordneter Frame dieses Fehlerdialogs
      * @param title Titel der Fehlermeldung
      */

        public FehlerDialog(Frame owner, String title){
            super(owner, title, true);
            setBounds(300, 300, 300, 150);
            setLayout(new BorderLayout());
            b1.setSize(80, 30);
            b1.addActionListener(this);
            p2.add(b1);
            add(p1, BorderLayout.CENTER);
            add(p2, BorderLayout.SOUTH);

        }


         public void actionPerformed(ActionEvent e) {
            setVisible(false);
            this.getParent().remove(this);
         }




        public void setErrorText(String ivErrorText) {
            TextArea t1 = new TextArea(ivErrorText, 4 ,30, TextArea.SCROLLBARS_NONE);
            t1.setBackground(SystemColor.control);
            t1.setEditable(false);
            this.p1.add(t1);
        }


    }
