package editor;

import com.borland.jbcl.layout.*;
import java.awt.*;
import java.sql.ResultSet;
import java.awt.event.*;
/**
 * Auswahlmaske welches Spielfeld gendert werden soll
 */
public class Spielfeldandern
    extends Panel {
  Sql db = new Sql();
  XYLayout xYLayout1 = new XYLayout();
  Choice cspielfeld = new Choice();
  Button bspielfeld = new Button();
  Button babbrechen = new Button();
  Label label1 = new Label();
  /**
   * Konstruktor erstellt die Auswahlmaske
   */
  public Spielfeldandern() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  //Mainmethode zu Testzwecken
  public static void main(String[] args) {
    Spielfeldandern spielfeldandern1 = new Spielfeldandern();
  }

  private void jbInit() throws Exception {

    bspielfeld.setLabel("ndern");
    bspielfeld.addActionListener(new Spielfeldandern_bspielfeld_actionAdapter(this));
    bspielfeld.setFont(new java.awt.Font("Dialog", 0, 13));
    this.setBackground(SystemColor.menu);
    this.setLayout(xYLayout1);
    babbrechen.setFont(new java.awt.Font("Dialog", 0, 13));
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new Spielfeldandern_babbrechen_actionAdapter(this));

    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Spielfeld ndern");
    xYLayout1.setWidth(325);
    xYLayout1.setHeight(300);
    this.add(label1, new XYConstraints(86, 19, 152, 26));
    this.add(cspielfeld, new XYConstraints(52, 83, 220, 23));
    this.add(babbrechen, new XYConstraints(52, 114, 103, -1));
    this.add(bspielfeld, new XYConstraints(165, 114, 107, -1));
    ResultSet result;
    result = db.select("select name from spielfeld");
    while (result.next()) {
      cspielfeld.add(result.getString("name"));
    }

  }

  void bspielfeld_actionPerformed(ActionEvent e) {
    Spielfeldgui g = new Spielfeldgui(cspielfeld.getSelectedItem());
    getParent().add(g);
    getParent().setVisible(false);
    getParent().setVisible(true);
    getParent().remove(this);
  }

  void babbrechen_actionPerformed(ActionEvent e) {
    getParent().remove(this);
  }
}

class Spielfeldandern_bspielfeld_actionAdapter
    implements java.awt.event.ActionListener {
  Spielfeldandern adaptee;

  Spielfeldandern_bspielfeld_actionAdapter(Spielfeldandern adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bspielfeld_actionPerformed(e);
  }
}

class Spielfeldandern_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Spielfeldandern adaptee;

  Spielfeldandern_babbrechen_actionAdapter(Spielfeldandern adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}